commit 18ce60477b189cb5d26906f0d08235ed9b076a80
Author: Tamar Christina <tamar.christina@arm.com>
Date:   Mon Aug 3 12:03:17 2020 +0100

    AArch64: Fix hwasan failure in readline.
    
    My previous fix added an unchecked call to fgets in the new function readline.
    fgets can fail when there's an error reading the file in which case it returns
    NULL.  It also returns NULL when the next character is EOF.
    
    The EOF case is already covered by the existing code but the error case isn't.
    This fixes it by returning the empty string on error.
    
    Also I now use strnlen instead of strlen to make sure we never read outside the
    buffer.
    
    This was flagged by Matthew Malcomson during his hwasan work.
    
    gcc/ChangeLog:
    
            * config/aarch64/driver-aarch64.c (readline): Check return value fgets.
    
    (cherry picked from commit 341573406b392f4d57e052ce22f80e85a7c479e9)

diff --git a/gcc/config/aarch64/driver-aarch64.c b/gcc/config/aarch64/driver-aarch64.c
index 28771a76827..8840a2d9486 100644
--- a/gcc/config/aarch64/driver-aarch64.c
+++ b/gcc/config/aarch64/driver-aarch64.c
@@ -194,10 +194,16 @@ readline (FILE *f)
       size += buf_size;
       buf = (char*) xrealloc (buf, size);
       gcc_assert (buf);
-      fgets (buf + last, buf_size, f);
+      /* If fgets fails it returns NULL, but if it reaches EOF
+	 with 0 characters read it also returns EOF.  However
+	 the condition on the loop would have broken out of the
+	 loop in that case,  and if we are in the first iteration
+	 then the empty string is the correct thing to return.  */
+      if (!fgets (buf + last, buf_size, f))
+	return std::string ();
       /* If we're not at the end of the line then override the
 	 \0 added by fgets.  */
-      last = strlen (buf) - 1;
+      last = strnlen (buf, size) - 1;
     }
   while (!feof (f) && buf[last] != '\n');
 

